Bug 1552631 (CVE-2018-1000121) - CVE-2018-1000121 curl: LDAP NULL pointer dereference
Summary: CVE-2018-1000121 curl: LDAP NULL pointer dereference
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2018-1000121
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
low
low
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1555208 1555207 1555209 1555210 1555221 1565031
Blocks: 1552634
TreeView+ depends on / blocked
 
Reported: 2018-03-07 13:11 UTC by Andrej Nemec
Modified: 2019-09-29 14:34 UTC (History)
23 users (show)

Fixed In Version: curl 7.59.0
Doc Type: If docs needed, set a value
Doc Text:
A NULL pointer dereference flaw was found in the way libcurl checks values returned by the openldap ldap_get_attribute_ber() function. A malicious LDAP server could use this flaw to crash a libcurl client application via a specially crafted LDAP reply.
Clone Of:
Environment:
Last Closed: 2019-06-10 10:16:53 UTC


Attachments (Terms of Use)
upstream patch (1.55 KB, patch)
2018-03-07 13:18 UTC, Andrej Nemec
no flags Details | Diff


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2018:3157 None None None 2018-10-30 07:43:35 UTC
Red Hat Product Errata RHSA-2018:3558 None None None 2018-11-13 08:35:26 UTC

Description Andrej Nemec 2018-03-07 13:11:01 UTC
It was found that curl might dereference a near-NULL address when getting an LDAP URL.

The function `ldap_get_attribute_ber()` is called to get attributes, but it
turns out that it can return `LDAP_SUCCESS` and still return a `NULL` pointer
in the result pointer when getting a particularly crafted response.

libcurl-using applications that allow LDAP URLs, or that allow redirects to
LDAP URLs could be made to crash by a malicious server.

Comment 1 Andrej Nemec 2018-03-07 13:11:03 UTC
Acknowledgments:

Name: the Curl project
Upstream: Dario Weisser

Comment 2 Andrej Nemec 2018-03-07 13:18:39 UTC
Created attachment 1405334 [details]
upstream patch

Comment 3 Adam Mariš 2018-03-14 07:29:45 UTC
External References:

https://curl.haxx.se/docs/adv_2018-97a2.html

Comment 4 Adam Mariš 2018-03-14 07:33:13 UTC
Created mingw-curl tracking bugs for this issue:

Affects: fedora-all [bug 1555207]


Created curl tracking bugs for this issue:

Affects: fedora-all [bug 1555209]


Created mingw-curl tracking bugs for this issue:

Affects: epel-7 [bug 1555208]

Comment 7 Cedric Buissart 🐶 2018-03-14 10:31:20 UTC
Upstream fix:
 openldap: check ldap_get_attribute_ber() results for NULL before using
https://github.com/curl/curl/commit/9889db0433

Comment 11 errata-xmlrpc 2018-10-30 07:43:23 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7

Via RHSA-2018:3157 https://access.redhat.com/errata/RHSA-2018:3157

Comment 12 errata-xmlrpc 2018-11-13 08:35:18 UTC
This issue has been addressed in the following products:

  Red Hat Software Collections for Red Hat Enterprise Linux 6
  Red Hat Software Collections for Red Hat Enterprise Linux 7
  Red Hat Software Collections for Red Hat Enterprise Linux 7.4 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7.5 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7.6 EUS

Via RHSA-2018:3558 https://access.redhat.com/errata/RHSA-2018:3558


Note You need to log in before you can comment on or make changes to this bug.